#include<reg51.h>
#include <string.h>
sbit rs = P2^7;					// rs pin of LCD
sbit en = P2^5;					// en pin of LCD
sbit rw = P2^6;					// rw pin of LCD
sbit b = P0^7;					// busy flag 
sbit led1 = P2^1;
sbit led2 = P2^2;
sbit led3 = P2^3;
sbit led4 = P2^4;
sbit op = P2^0;

unsigned int d1=0; 
unsigned int d2=0;
unsigned int c=0;

void writecmd(unsigned char a);	// function initializations
void writedata(unsigned char b);
void busy(void);
void writestr(unsigned char *s);
void dely(void);
void incangle(void);
void decangle(void);
void delay(int d);
void display(unsigned int z);

void keydly(void)
  {
    unsigned int x,y;
    for(x=0;x<100;x++)
	    for(y=0;y<1000;y++);
  }	
void decangle()
  {
  	EX1=0;
    writecmd(0xC0);
	led3=1;
    if(d1>0) 
	  {  
		d1--;
		d2-=18;
		writestr("angle:");
		display(d2);
		writestr(" deg.  ");
	  }	
	else if(d1==0) writestr("Min phase angle ");	
	led3=0;
    EX1=1;
  }
void incangle()
  {
  	EX1=0;
	writecmd(0xC0);
	led4=1;
    if(d1<9) 
	  {
		d1++;
		d2+=18;
		writestr("angle:");
		display(d2);
		writestr(" deg.  ");
	  }
	else if(d1==9) writestr("Max phase angle ");
	led4=0;
	EX1=1;
  }
void delay(int d)
 {
	int k;
	TL0 = 0x17;
	TH0 = 0xFC;
	TR0 = 1;
	for(k=0;k<d;k++)
	  {
		while(TF0==0);
		TF0 = 0;
		TL0 = 0x17;
		TH0 = 0xFC;
	  }
	TR0 = 0;
}
    
void writecmd(unsigned char a)
{
	busy();
	rs = 0;
	rw = 0;
	P0 = a;	
	en = 1;
	en = 0;
}
void writedata(unsigned char b)
{
	busy();
	rs = 1;
	rw = 0;
	P0 = b;	
	en = 1;
	en = 0;	
}
void busy()
{
	en = 0;
	P0 = 0xFF;
	rs = 0;
	rw = 1;
	while(b==1)
	{
	 en=0;
	 en=1;
	}
	en=0;
}
void writestr(unsigned char *s)
{
	unsigned char l,i;
	l = strlen(s);
	for(i=0;i<l;i++)
	{
		writedata(*s);
		s++;		
	}
}
void display(unsigned int z)
  {
  	int z1,a,ASCII[3];
    if(z>=100)
	  {
		a=2;
		while(z>=10)
		{		
			z1=z%10;
			ASCII[a]=z1+0x30;
			z=z/10;
			a--;
		}
		ASCII[0]=z+0x30;
	  }
	else
	  {
		z1=z%10;
		ASCII[2]=z1+0x30;
		z=z/10;
		ASCII[1]=z+0x30;
		ASCII[0]=0x30;
	  }
	writedata(ASCII[0]);
	writedata(ASCII[1]);
	writedata(ASCII[2]);
  }
void int0(void) interrupt 0
  {
    switch(P1)
	  {
	    case 0xFE:
			keydly();
			c++;
			if((c%2)==1) 
			  {
		  		writecmd(0x01);
				writestr("SCR ON ");
				writecmd(0xC0);
				writestr("angle:");
				display(d2);
				writestr(" deg.  ");
				led2=0;
				EX1 = 1;
			  } 
			else 
			  {
			  	writecmd(0x01);
				writestr("SCR OFF ");
				led2=1;
			  	EX1 = 0;
			  }
			break;
		case 0xFD:
			keydly();
			incangle();
			break;
		case 0xFB:
			keydly();
			decangle();
			break;
	   }
	}

 void int1(void) interrupt 2
   {
   		int t;
		led1=1;
		delay(d1);
		op=1;	
		for(t=0;t<200;t++);
		op=0;
		led1 = 0;		
   }

void main()
  {
    TMOD = 0x01;
	P2=0x00;
    P0=0x00;
	P1=0xFF;
	writecmd(0x3C);
	writecmd(0x0E); 
	writecmd(0x01);
    writestr("SCR Phase angle");
	writecmd(0xC4);
	writestr("Control");
	led2=1;
	IE=0x81;
	while(1);
  }

